<!--
  ~ Benchmarking Suite
  ~ Copyright 2014-2022 Engineering Ingegneria Informatica S.p.A.
  ~
  ~ Licensed under the Apache License, Version 2.0 (the "License");
  ~ you may not use this file except in compliance with the License.
  ~ You may obtain a copy of the License at
  ~
  ~ http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing, software
  ~ distributed under the License is distributed on an "AS IS" BASIS,
  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~ See the License for the specific language governing permissions and
  ~ limitations under the License.
  -->

<template>

  <v-list-item three-line
    @click="$emit('selected', item)"
    :class="'abstract-workload-'+item.abstract"
  >
    <v-list-item-avatar>
      <v-icon>mdi-tape-measure</v-icon>
    </v-list-item-avatar>

    <v-list-item-content>
      <v-list-item-title>
        <span v-if="item.abstract">
          &lt;abstract&gt;
        </span>
        {{item.name}} ({{item.tool}})
        <v-icon small v-if="sharing=='private'">mdi-lock</v-icon>
        <v-icon small v-if="sharing=='public'">mdi-earth</v-icon>
        <v-icon small v-if="sharing=='shared'">mdi-share-variant</v-icon>
      </v-list-item-title>

      <v-list-item-subtitle class="wrap-text" style="width:100px">
        {{item.description}}
      </v-list-item-subtitle>

      <div align="right">
        <v-chip
          v-for="(cat) in item.categories"
          :key="cat"
          class="ma-1"
          small
          label
        >#{{cat}}</v-chip>
        <v-chip label small class="ma-1" v-if="item.abstract">#abstract</v-chip>
        <v-chip label small class="ma-1" v-if="sharing=='public'"><v-icon small left>mdi-earth</v-icon>public</v-chip>
        <v-chip label small class="ma-1" v-if="sharing=='private'"><v-icon small left>mdi-lock</v-icon>private</v-chip>
        <v-chip label small class="ma-1" v-if="sharing=='shared'"><v-icon small left>mdi-share-variant</v-icon>shared</v-chip>
      </div>
    </v-list-item-content>

     <v-list-item-action v-if="remove">
        <v-btn icon>
          <v-icon
              v-on:click="$emit('delete', item)"
          >mdi-delete</v-icon>
        </v-btn>
     </v-list-item-action>

  </v-list-item>

</template>

<script>

import { getWorkloadSharingLevel } from '../common/benchsuite.js';

export default {

 name: 'WorkloadSummary',

  components: {
  },

  props: {
    item: {
      type: Object,
      default: function() {return {}}
    },
    remove: {
      type: String
    }
  },

  computed: {
    sharing() {
      return getWorkloadSharingLevel(this.item);
    }
  }


};

</script>

<style>

  .abstract-workload-true {
    color:grey;
    font-style:italic;
  }

</style>
